(function () {
    var endCallback = function () {
        // cocoon doesnt call the callback on close
        var wrapper = window.parent.document.getElementById('cocoonjswrapper');
        console.log(wrapper)
        if (wrapper) {
            wrapper.parentNode.removeChild(wrapper);
        }

        try {
            if (Cocoon.Widget.WebDialog.close) {
                Cocoon.Widget.WebDialog.close();
            }
        } catch (e) {}
        close.removeEventListener('click', endCallback);
        close.removeEventListener('touchstart', endCallback);
        // close cocoon webview
        try {
            Cocoon.WebView.hide();
            Cocoon.Touch.enable();
        } catch (e) {}

    };
    window.addEventListener('load', function () {
        close = document.getElementById('close');
        close.addEventListener('click', endCallback);
        close.addEventListener('touchstart', endCallback);
        try {
            Cocoon.Touch.disable();
        } catch (e) {}
    }, false);

    window.addAchievements = function (achs) {
        var i = 0,
            rows = document.getElementById('rows');
        for (i = 0; i < achs.length; ++i) {
            var tr = document.createElement('tr'),
                td1 = document.createElement('td'),
                td2 = document.createElement('td'),
                img = document.createElement('img'),
                ach = achs[i];
            // is unlocked?
            if (ach.achieved) {
                if (ach.gpAchievementData) {
                    img.src = ach.gpAchievementData.unlockedIconUrl;
                } else if (ach.imageURL) {                    
                    img.src = ach.imageURL;
                } 
            } else {
                // img.src = ach.gpAchievementData.revealedIconUrl;
                img.src = 'image/locked.png';
            }
            img.className = 'ach-icon';
            td1.appendChild(img);
            td1.style.padding = '0px';
            // td2.innerHTML = '<h3><small>' + ach.gpAchievementData.name + '</small></h3>' + ach.gpAchievementData.description;
            td2.innerHTML = '<h3><small>' + ach.title + '</small></h3>' + ach.description;
            tr.appendChild(td1);
            tr.appendChild(td2);
            rows.appendChild(tr);
        }
    };
})();