(function () {
    var spinner,
        loader,
        scores = [],
        rows,
        currentlyShowing = 0,
        endCallback = function () {
            try {
                if (Cocoon.Widget.WebDialog.close) {
                    Cocoon.Widget.WebDialog.close();
                }
            } catch (e) {}
            close.removeEventListener('click', endCallback);
            close.removeEventListener('touchstart', endCallback);
            // close cocoon webview
            try {
                Cocoon.WebView.hide();
                Cocoon.Touch.enable();
            } catch (e) {}
        },
        isElementInViewport = function (el) {
            var rect = el.getBoundingClientRect();
            return (
                rect.top <= (window.innerHeight || document.documentElement.clientHeight)
            );
        },
        appendScore = function (i) {
            if (!rows) {
                rows = document.getElementById('rows');
            }
            var tr = document.createElement('tr'),
                td1 = document.createElement('td'),
                td2 = document.createElement('td'),
                td3 = document.createElement('td'),
                td4 = document.createElement('td'),
                img = document.createElement('img');
            if (scores[i].imageURL === 'undefined?sz=50') {
                img.src = 'image/user.png';
            } else {
                img.src = scores[i].imageURL;
            }
            td1.innerHTML = scores[i].position;
            td2.appendChild(img);
            td2.style.padding = '0px';
            td3.innerHTML = scores[i].userName;
            td4.innerHTML = scores[i].score;
            tr.appendChild(td1);
            tr.appendChild(td2);
            tr.appendChild(td3);
            tr.appendChild(td4);
            rows.appendChild(tr);          
            currentlyShowing++;
        };

    window.appendScores = function () {
        // load next 50 scores
        var i = 0,
            next = 0;
        for (i = 0; i < 50; ++i) {
            next = currentlyShowing + 1;
            if (next > scores.length) {
                break;
            }
            appendScore(next - 1);
        }
    };
    window.clearScores = function () {};
    // cocoon
    window.addMyScore = function (score) {
        if (!rows) {
            rows = document.getElementById('rows');
        }
        // this score doesnt count towards the total
        var tr = document.createElement('tr'),
            td1 = document.createElement('td'),
            td2 = document.createElement('td'),
            td3 = document.createElement('td'),
            td4 = document.createElement('td'),
            img = document.createElement('img');
        img.src = score.imageURL;
        td1.innerHTML = score.position;
        td2.appendChild(img);
        td2.style.padding = '0px';
        td3.innerHTML = score.userName;
        td4.innerHTML = score.score;
        tr.appendChild(td1);
        tr.appendChild(td2);
        tr.appendChild(td3);
        tr.appendChild(td4);
        tr.className = 'info';
        rows.insertBefore(tr, rows.firstChild);
    };
    window.test = 0;
    window.addScores = function (array) {
        var i = 0;
        // sort to be sure
        array.sort(function (a, b) {
            return a.position - b.position;
        });
        scores = array;
        // find my score and place it on top
        /*for (i = 0; i < scores.length; ++i) {
            if (scores[i].me) {
                appendScore(i);
                break;
            }
        }*/
        appendScores();
    };

    var handler = function () {
        if (!loader) {
            loader = document.getElementById('loader');
        }
        if (loader && isElementInViewport(loader)) {
            appendScores();
        }
    };
    //non-jQuery
    if (window.addEventListener) {
        addEventListener('DOMContentLoaded', handler, false);
        addEventListener('load', handler, false);
        addEventListener('scroll', handler, false);
        addEventListener('resize', handler, false);
        addEventListener('load', function () {
            close = document.getElementById('close');
            close.addEventListener('click', endCallback);
            close.addEventListener('touchstart', endCallback);
            try {
                Cocoon.Touch.disable();
            } catch (e) {}
        }, false);
    } else if (window.attachEvent) {
        attachEvent('onDOMContentLoaded', handler); // IE9+ :(
        attachEvent('onload', handler);
        attachEvent('onscroll', handler);
        attachEvent('onresize', handler);
    }

})();